# coding: utf-8

"""
    Statuspage API

    # Code of Conduct Please don't abuse the API, and please report all feature requests and issues to https://support.atlassian.com/contact  # Rate Limiting Each API token is limited to 1 request / second as measured on a 60 second rolling window. To get this limit increased, please contact us at https://support.atlassian.com/contact  Error codes 420 or 429 indicate that you have exceeded the rate limit and the request has been rejected.  # Basics  ## HTTPS It's required  ## URL Prefix In order to maintain version integrity into the future, the API is versioned. All calls currently begin with the following prefix:    https://api.statuspage.io/v1/  ## RESTful Interface Wherever possible, the API seeks to implement repeatable patterns with logical, representative URLs and descriptive HTTP verbs. Below are some examples and conventions you will see throughout the documentation.  * Collections are buckets: https://api.statuspage.io/v1/pages/asdf123/incidents.json * Elements have unique IDs: https://api.statuspage.io/v1/pages/asdf123/incidents/jklm456.json * GET will retrieve information about a collection/element * POST will create an element in a collection * PATCH will update a single element * PUT will replace a single element in a collection (rarely used) * DELETE will destroy a single element  ## Sending Data Information can be sent in the body as form urlencoded or JSON, but make sure the Content-Type header matches the body structure or the server gremlins will be angry.  All examples are provided in JSON format, however they can easily be converted to form encoding if required.  Some examples of how to convert things are below:      // JSON     {       \"incident\": {         \"name\": \"test incident\",         \"components\": [\"8kbf7d35c070\", \"vtnh60py4yd7\"]       }     }      // Form Encoded (using curl as an example):     curl -X POST https://api.statuspage.io/v1/example \\       -d \"incident[name]=test incident\" \\       -d \"incident[components][]=8kbf7d35c070\" \\       -d \"incident[components][]=vtnh60py4yd7\"  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PostPagesPageIdPageAccessGroupsPageAccessGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'external_identifier': 'str',
        'component_ids': 'list[str]',
        'metric_ids': 'list[str]',
        'page_access_user_ids': 'list[str]'
    }

    attribute_map = {
        'name': 'name',
        'external_identifier': 'external_identifier',
        'component_ids': 'component_ids',
        'metric_ids': 'metric_ids',
        'page_access_user_ids': 'page_access_user_ids'
    }

    def __init__(self, name=None, external_identifier=None, component_ids=None, metric_ids=None, page_access_user_ids=None):  # noqa: E501
        """PostPagesPageIdPageAccessGroupsPageAccessGroup - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._external_identifier = None
        self._component_ids = None
        self._metric_ids = None
        self._page_access_user_ids = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if external_identifier is not None:
            self.external_identifier = external_identifier
        if component_ids is not None:
            self.component_ids = component_ids
        if metric_ids is not None:
            self.metric_ids = metric_ids
        if page_access_user_ids is not None:
            self.page_access_user_ids = page_access_user_ids

    @property
    def name(self):
        """Gets the name of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501

        Name for this Group.  # noqa: E501

        :return: The name of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PostPagesPageIdPageAccessGroupsPageAccessGroup.

        Name for this Group.  # noqa: E501

        :param name: The name of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def external_identifier(self):
        """Gets the external_identifier of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501

        Associates group with external group.  # noqa: E501

        :return: The external_identifier of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :rtype: str
        """
        return self._external_identifier

    @external_identifier.setter
    def external_identifier(self, external_identifier):
        """Sets the external_identifier of this PostPagesPageIdPageAccessGroupsPageAccessGroup.

        Associates group with external group.  # noqa: E501

        :param external_identifier: The external_identifier of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :type: str
        """

        self._external_identifier = external_identifier

    @property
    def component_ids(self):
        """Gets the component_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501


        :return: The component_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :rtype: list[str]
        """
        return self._component_ids

    @component_ids.setter
    def component_ids(self, component_ids):
        """Sets the component_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.


        :param component_ids: The component_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :type: list[str]
        """

        self._component_ids = component_ids

    @property
    def metric_ids(self):
        """Gets the metric_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501


        :return: The metric_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :rtype: list[str]
        """
        return self._metric_ids

    @metric_ids.setter
    def metric_ids(self, metric_ids):
        """Sets the metric_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.


        :param metric_ids: The metric_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :type: list[str]
        """

        self._metric_ids = metric_ids

    @property
    def page_access_user_ids(self):
        """Gets the page_access_user_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501


        :return: The page_access_user_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :rtype: list[str]
        """
        return self._page_access_user_ids

    @page_access_user_ids.setter
    def page_access_user_ids(self, page_access_user_ids):
        """Sets the page_access_user_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.


        :param page_access_user_ids: The page_access_user_ids of this PostPagesPageIdPageAccessGroupsPageAccessGroup.  # noqa: E501
        :type: list[str]
        """

        self._page_access_user_ids = page_access_user_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostPagesPageIdPageAccessGroupsPageAccessGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostPagesPageIdPageAccessGroupsPageAccessGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
